<!-- This comment is uncommented when auto-synced to www-kluctl.io

---
title: "Commands"
linkTitle: "Commands"
weight: 10
description: >
    Description of available commands.
---
-->

# Commands

kluctl offers a unified command line interface that allows to standardize all your deployments. Every project,
no matter how different it is from other projects, is managed the same way.

You can always call `kluctl --help` or `kluctl <command> --help` for a help prompt.

Individual commands are documented in sub-sections.

## Table of Contents

1. [Common Arguments](./common-arguments.md)
2. [Environment Variables](./environment-variables.md)
3. [delete](./delete.md)
4. [deploy](./deploy.md)
5. [diff](./diff.md)
6. [helm-pull](./helm-pull.md)
7. [helm-update](./helm-update.md)
8. [list-images](./list-images.md)
9. [list-targets](./list-targets.md)
10. [poke-images](./poke-images.md)
11. [prune](./prune.md)
12. [render](./render.md)
13. [validate](./validate.md)
